import java.util.*;
import java.text.*;
public class Personne{
    private static int numero = 0;
    private static Random alea = new Random();
    private static SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
    private int ident;
    private Date naissance, deces;
    private boolean masculin;
    private boolean celibataire, marie, divorce, veuf, mort;

    public Personne(boolean garcon){
        ident = numero++;
	naissance = new Date();
	deces = null;
	masculin = garcon;
	celibataire = true;
	marie = false;
	divorce = false;
	veuf = false;
	mort = false;
    }

    public String toString(){
	String res ="";
	if (masculin) {
	    res +="Monsieur "+ident+", ne le ";
	    res += sdf.format(naissance)+", est";
	    if (celibataire) res +=" celibataire.\n";
	    if (marie)       res +=" marie.\n";
	    if (divorce)     res +=" divorce.\n";
	    if (veuf)        res +=" veuf.\n";
	    if (mort)        res +=" mort le "+sdf.format(deces)+".\n";
	}
	else {
	    if (celibataire){
		res +="Mademoiselle "+ident+", est nee le ";
		res += sdf.format(naissance)+".\n";
	    }
	    else{
		res +="Madame "+ident+", nee le ";
		res += sdf.format(naissance)+", est";
	    }
	    if (marie)       res +=" mariee.\n";
	    if (divorce)     res +=" divorcee.\n";
	    if (veuf)        res +=" veuve.\n";
	    if (mort)        res +=" morte le "+sdf.format(deces)+".\n";
	}
	return res;
    }

    public void mourir() throws Exception{
	if (mort)
	    throw new Exception("Impossible");
	else {
	    deces = new Date();
	    celibataire = false;
	    marie = false;
	    divorce = false;
	    veuf = false;
	    mort = true;
	}
    }
    
    public void seMarier() throws Exception{
	if (mort || marie)
	    throw new Exception("Impossible");
	else {
	    celibataire = false;
	    marie = true;
	    divorce = false;
	    veuf = false;
	    mort = false;
	}
    }
    
    public void divorcer() throws Exception{
	if (mort || celibataire || veuf || divorce)
	    throw new Exception("Impossible");
	else {
	    celibataire = false;
	    marie = false;
	    divorce = true;
	    veuf = false;
	    mort = false;
	}
    }
    
    public void mortConjoint() throws Exception{
	if (mort || celibataire || veuf || divorce)
	    throw new Exception("Impossible");
	else {
	    celibataire = false;
	    marie = false;
	    divorce = false;
	    veuf = true;
	    mort = false;
	}
    }
    
    public void vieillir() {
	try {Thread.sleep(2000);}       // 2 secondes d'endormissement
	catch(InterruptedException ie){}
	finally {
	    int a = alea.nextInt(4);
	    try {
		switch (a) {
		case 0 : mourir(); break;
		case 1 : seMarier(); break;
		case 2 : divorcer(); break;
		case 3 : mortConjoint();
		}
		System.out.print(this);
	    }
	    catch (Exception e){} // Exceptions lors de chgt de situation
	}
    }

}
